3 ### Build script for Debian packages
5 ### (c) 2008 Mark Wooding
8 ###----- Licensing notice ---------------------------------------------------
10 ### This program is free software; you can redistribute it and/or modify
11 ### it under the terms of the GNU General Public License as published by
12 ### the Free Software Foundation; either version 2 of the License, or
13 ### (at your option) any later version.
15 ### This program is distributed in the hope that it will be useful,
16 ### but WITHOUT ANY WARRANTY; without even the implied warranty of
17 ### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18 ### GNU General Public License for more details.
20 ### You should have received a copy of the GNU General Public License
21 ### along with this program; if not, write to the Free Software Foundation,
22 ### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
24 ###--------------------------------------------------------------------------
25 ### Conventions for build systems.
27 ### This script is designed to work with a variety of `make'-based build
28 ### systems, but there are a number of conventions which must be followed if
29 ### this is going to work properly.
31 ### * There must be a `configure.ac', `configure.in', or `.links' file, or
32 ### a `.git' directory in the project top-level, so that we can find it.
34 ### * The following `make' variables must be assigned in the top-level
35 ### Makefile, after `mdw-build' has constructed it.
37 ### distdir The name of the top-level project directory in the
38 ### source distribution, and the base name for
39 ### distribution archives; should be of the form
40 ### `PROJECT-VERSION'.
42 ### The following `make' targets must be available in the top-level
45 ### dist Write to $(distdir).tar.gz a source distribution of
48 ### distcheck As for `dist', but also build and test the project.
50 ### * The source distribution constructed by `make dist' must contain a file
51 ### $(distdir)/RELEASE containing the release name. This isn't currently
52 ### tested, but it might be later.
56 ###--------------------------------------------------------------------------
61 Usage: $0 [-vr] BUILDOPT
77 ## Parse simple options.
79 while getopts "hvr" opt; do
88 ## Parse the build options.
102 checkout) checkout=yes checkoutrev=HEAD ;;
103 checkout=*) checkout=yes checkoutrev=${opt#*=} ;;
104 release) build=release ;;
105 norelease) build=test ;;
106 setup) setup=yes setupcmd=mdw-setup ;;
107 setup=*) setup=yes setupcmd=${opt#*=} ;;
109 distcheck | debian | upload | clean | vpath | native)
112 nocheckout | nosetup | nodistcheck | nodebian | \
113 noupload | noclean | novpath | nonative)
123 ## Parse DEB_BUILD_OPTIONS.
125 set -- $DEB_BUILD_OPTIONS
128 parallel=*) jobs=${opt#*=} ;;
133 case $jobs in 1) ;; *) makeopts="$makeopts -j$jobs" ;; esac
135 ###--------------------------------------------------------------------------
136 ### Utility functions.
138 exec 3>&2 4>/dev/null 5>&2
143 echo "$(tput bold; tput setaf $colour)$message$(tput sgr0; tput op)" >&5
153 release) fail "$*" ;;
154 *) notify 5 "??? $*" ;;
169 "$@" 2>&3 || fail "$1: exit $?"
172 run () { runx "$@" >&3; }
175 echo -n "(test $*)" >&4
176 if "$@" >&4 2>&4; then
185 ###--------------------------------------------------------------------------
188 ## Find the top-level package directory.
189 while [ ! -f configure.ac -a ! -f configure.in -a \
190 ! -f .links -a ! -d .git ]; do
193 fail "couldn't find top-level directory"
198 assign srcpath $(pwd)
200 ## Construct the output directory.
201 assign releasepath $srcpath/dist-$build
202 chmod -R +w $releasepath 2>/dev/null || :
203 rm -rf $releasepath 2>/dev/null || :
207 exec 4>$releasepath/mdw-build.log 3>&4 ||
208 fail "Failed to create log."
212 ## Do we have a Git repository?
213 case "$checkout,$setup,$(yesno [ -d $srcpath/.git ])" in
215 fail "Inconsistent options: can't check out without setup."
218 info "No Git repository found."
219 checkout=no gitver=none
223 [ "$(git ls-files -m)" = "" ] ||
224 warn "working tree has uncommitted changes"
225 gitver=$(git describe --abbrev=4)
229 ## Is there Debian build equipment?
230 case "$debian,$(yesno [ -d $srcpath/debian ])" in
232 info "No debian directory found."
233 debian=no debver=none
239 debver=$(dpkg-parsechangelog | sed -n 's/^Version: //p' | tr \~ -)
240 debsrc=$(dpkg-parsechangelog | sed -n 's/^Source: //p')
241 debname=$(git config user.name) debemail=$(git config user.email)
245 ## Check the version number.
247 case "$gitver,$debver" in
251 if [ "$gitver" != "$debver" ]; then
252 warn "Git version $gitver doesn't match Debian version $debver"
258 ## Maybe check out a copy of the source.
262 run git clone -sn $srcpath/.git _source
263 assign srcpath $releasepath/_source
265 run git checkout -b mdw-build $checkoutrev
269 ## Maybe refresh the build machinery.
276 ## Initialize the build directory.
277 case "$vpath,$(yesno [ -e $srcpath/configure ])" in
279 assign buildpath $releasepath/_build
282 run $srcpath/configure
285 info "VPATH build disabled"
286 assign buildpath $srcpath
292 info "no configure script"
293 assign buildpath $srcpath
298 ## Discover the release name.
299 cat >find-distdir.mk <<'EOF'
305 $({ make -f find-distdir.mk print-distdir >/dev/null 2>&1; } 3>&1)
307 ## Get a tarball distribution.
310 run make $makeopts distcheck
313 run make $makeopts dist
321 if ! tar tf $buildpath/$distdir.tar.gz 2>/dev/null | grep -q RELEASE
323 fail "missing RELEASE file in distribution"
328 run mv $buildpath/$distdir.tar.gz .
331 run gpg -u$(mdw-conf releasekey) -ab -o$distdir.tar.gz.gpg \
336 ## Maybe build the Debian packages.
339 run tar xvfz $distdir.tar.gz
343 dver=$(echo $gitver | sed 's/-/+/; s/-/./g')
345 cat - debian/changelog >debian/changelog.new <<EOF
346 $debsrc ($dver) experimental; urgency=low
348 * Hacking in process, not intended for release.
350 -- $debname <$debemail> $now
353 mv debian/changelog.new debian/changelog
356 run dpkg-buildpackage -k$(mdw-conf releasekey)
360 ## Maybe upload Debian packages.
362 case "$upload,$build" in
364 info "Test build: not uploading."
367 run rsync $distdir.tar.gz $distdir.tar.gz.gpg \
368 $(mdw-conf upload-target ftp.distorted.org.uk:~ftp/pub/mdw/)
371 run dput -f $(mdw-conf dput-target distorted) *.changes
379 rm -rf $releasepath/$distdir
380 rm -rf $releasepath/_source
381 rm -rf $releasepath/_build
388 ###----- That's all, folks --------------------------------------------------